import 'repository.dart';

abstract class CommonResult<TAction extends Action<CommonResult<TAction>>> {
  const CommonResult(this.action);
  final TAction action;
}

abstract class InvalidArguments<TAction extends Action<CommonResult<TAction>>>
    extends CommonResult<TAction> {
  const InvalidArguments(TAction action) : super(action);
}

class UnexpectedError<TAction extends Action<CommonResult<TAction>>>
    extends CommonResult<TAction> {
  const UnexpectedError(TAction action,
      {this.timeout = false,
      this.unauthorized = false,
      this.forbidden = false,
      this.unknown = false})
      : super(action);

  final bool timeout;
  final bool unauthorized;
  final bool forbidden;
  final bool unknown;
}
